## luarocks 0.6.0.2

=== Makefile ===
# $Id: Makefile,v 1.28 2008/06/30 12:40:38 hisham Exp $

include config.unix

DESTDIR =
PREFIX ?= /usr/local
BINDIR ?= $(PREFIX)/bin
LUADIR ?= $(PREFIX)/share/lua/5.1/
LUA_DIR ?= /usr/local
LUA_BINDIR ?= $(LUA_DIR)/bin

BIN_FILES = luarocks luarocks-admin
LUAROCKS_FILES = build/cmake.lua build/command.lua build.lua build/make.lua \
command_line.lua cfg.lua deps.lua fetch.lua fs.lua fs/unix.lua \
fs/win32.lua help.lua install.lua list.lua persist.lua \
make_manifest.lua pack.lua path.lua rep.lua require.lua search.lua \
type_check.lua util.lua remove.lua build/builtin.lua make.lua manif.lua unpack.lua \
fetch/cvs.lua fetch/sscm.lua

CONFIG_FILE = $(SYSCONFDIR)/config.lua

all:
	for f in $(BIN_FILES) ;\
	do \
	   sed "1d" src/bin/$$f >> src/bin/$$f.bak ;\
	   echo "#!$(LUA_BINDIR)/lua$(LUA_SUFFIX)" > src/bin/$$f ;\
	   echo "package.path = [[$(LUADIR)/?.lua;$(LUADIR)/?/init.lua;]]..package.path" >> src/bin/$$f ;\
	   cat src/bin/$$f.bak >> src/bin/$$f ;\
	   rm src/bin/$$f.bak ;\
	done
	cp src/luarocks/cfg.lua src/luarocks/cfg.lua.bak
	rm src/luarocks/cfg.lua
	if [ "$(LUA_INCDIR)" ] ;\
	then \
	   echo "local LUA_INCDIR=[[$(LUA_INCDIR)]]" >> src/luarocks/cfg.lua ;\
	fi
	if [ "$(LUA_LIBDIR)" ] ;\
	then \
	   echo "local LUA_LIBDIR=[[$(LUA_LIBDIR)]]" >> src/luarocks/cfg.lua ;\
	fi
	if [ "$(LUA_BINDIR)" ] ;\
	then \
	   echo "local LUA_BINDIR=[[$(LUA_BINDIR)]]" >> src/luarocks/cfg.lua ;\
	fi
	if [ "$(LUA_SUFFIX)" ] ;\
	then \
	   echo "local LUA_INTERPRETER=[[lua$(LUA_SUFFIX)]]" >> src/luarocks/cfg.lua ;\
	fi
	if [ "$(SYSCONFDIR)" ] ;\
	then \
	   echo "local LUAROCKS_SYSCONFIG=[[$(SYSCONFDIR)/config.lua]]" >> src/luarocks/cfg.lua ;\
	fi
	if [ "$(ROCKS_TREE)" ] ;\
	then \
	   echo "local LUAROCKS_ROCKS_TREE=[[$(ROCKS_TREE)]]" >> src/luarocks/cfg.lua ;\
	fi
	if [ "$(FORCE_CONFIG)" ] ;\
	then \
	   echo "local LUAROCKS_FORCE_CONFIG=true" >> src/luarocks/cfg.lua ;\
	fi
	echo "local LUAROCKS_UNAME_S=[[$(LUAROCKS_UNAME_S)]]" >> src/luarocks/cfg.lua
	echo "local LUAROCKS_UNAME_M=[[$(LUAROCKS_UNAME_M)]]" >> src/luarocks/cfg.lua
	echo "local LUAROCKS_DOWNLOADER=[[$(LUAROCKS_DOWNLOADER)]]" >> src/luarocks/cfg.lua
	echo "local LUAROCKS_MD5CHECKER=[[$(LUAROCKS_MD5CHECKER)]]" >> src/luarocks/cfg.lua
	cat src/luarocks/cfg.lua.bak >> src/luarocks/cfg.lua
	rm src/luarocks/cfg.lua.bak
	@echo
	@echo "Done. Type 'make install' to install into $(PREFIX)."
	@echo

luadoc:
	rm -rf doc/luadoc
	mkdir -p doc/luadoc
	cd src && luadoc -d ../doc/luadoc --nofiles luarocks/*.lua

check_makefile:
	echo $(BIN_FILES) | tr " " "\n" | sort > makefile_list.txt
	( cd src/bin && ls -d * ) | grep -v "CVS" | sort > luarocks_dir.txt
	echo $(LUAROCKS_FILES) | tr " " "\n" | sort >> makefile_list.txt
	( cd src/luarocks && ls -d *.lua ) | sort >> luarocks_dir.txt
	diff makefile_list.txt luarocks_dir.txt
	rm makefile_list.txt luarocks_dir.txt
	@echo
	@echo "Makefile is sane."
	@echo

clean:
	for f in $(BIN_FILES) ;\
	do \
	   sed -i.bak "s,^#!.*lua.*,#!/usr/bin/env lua,;/^package.path/d" src/bin/$$f ;\
	   rm src/bin/$$f.bak ;\
	done
	sed -i.bak "/^local LUA/d" src/luarocks/cfg.lua
	rm src/luarocks/cfg.lua.bak

install:
	mkdir -p "$(DESTDIR)$(BINDIR)"
	cd src/bin && cp $(BIN_FILES) "$(DESTDIR)$(BINDIR)"
	mkdir -p "$(DESTDIR)$(LUADIR)/luarocks"
	cd src/luarocks && for f in $(LUAROCKS_FILES); do d="$(DESTDIR)$(LUADIR)/luarocks"/`dirname "$$f"`; mkdir -p "$$d"; cp "$$f" "$$d"; done
	mkdir -p "$(DESTDIR)$(ROCKS_TREE)"
	if [ ! -e "$(DESTDIR)$(CONFIG_FILE)" ] ;\
	then \
	   mkdir -p `dirname "$(DESTDIR)$(CONFIG_FILE)"` ;\
	   echo 'rocks_servers = {' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   echo '   [[http://luarocks.luaforge.net/rocks]]' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   echo '}' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   echo 'rocks_trees = {' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   if ! [ "$(FORCE_CONFIG)" ] ;\
	   then \
	      echo '   home..[[/.luarocks]],' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   fi ;\
	   echo '   [[$(ROCKS_TREE)]]' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   echo '}' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   if [ "$(SCRIPTS_DIR)" ] ;\
	   then \
	      echo "scripts_dir = [[$(SCRIPTS_DIR)]]" >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   fi ;\
	fi

## luarocks 1.0.1

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.28 2008/06/30 12:40:38 hisham Exp $
+# $Id: Makefile,v 1.30 2008/08/18 14:07:35 hisham Exp $
 
 include config.unix
 
@@ -15,7 +15,7 @@
 fs/win32.lua help.lua install.lua list.lua persist.lua \
 make_manifest.lua pack.lua path.lua rep.lua require.lua search.lua \
 type_check.lua util.lua remove.lua build/builtin.lua make.lua manif.lua unpack.lua \
-fetch/cvs.lua fetch/sscm.lua
+fetch/cvs.lua fetch/sscm.lua fetch/git.lua
 
 CONFIG_FILE = $(SYSCONFDIR)/config.lua
 
@@ -30,31 +30,35 @@
 	done
 	cp src/luarocks/cfg.lua src/luarocks/cfg.lua.bak
 	rm src/luarocks/cfg.lua
-	if [ "$(LUA_INCDIR)" ] ;\
+	if [ -n "$(PREFIX)" ] ;\
+	then \
+	   echo "local LUAROCKS_PREFIX=[[$(PREFIX)]]" >> src/luarocks/cfg.lua ;\
+	fi
+	if [ -n "$(LUA_INCDIR)" ] ;\
 	then \
 	   echo "local LUA_INCDIR=[[$(LUA_INCDIR)]]" >> src/luarocks/cfg.lua ;\
 	fi
-	if [ "$(LUA_LIBDIR)" ] ;\
+	if [ -n "$(LUA_LIBDIR)" ] ;\
 	then \
 	   echo "local LUA_LIBDIR=[[$(LUA_LIBDIR)]]" >> src/luarocks/cfg.lua ;\
 	fi
-	if [ "$(LUA_BINDIR)" ] ;\
+	if [ -n "$(LUA_BINDIR)" ] ;\
 	then \
 	   echo "local LUA_BINDIR=[[$(LUA_BINDIR)]]" >> src/luarocks/cfg.lua ;\
 	fi
-	if [ "$(LUA_SUFFIX)" ] ;\
+	if [ -n "$(LUA_SUFFIX)" ] ;\
 	then \
 	   echo "local LUA_INTERPRETER=[[lua$(LUA_SUFFIX)]]" >> src/luarocks/cfg.lua ;\
 	fi
-	if [ "$(SYSCONFDIR)" ] ;\
+	if [ -n "$(SYSCONFDIR)" ] ;\
 	then \
 	   echo "local LUAROCKS_SYSCONFIG=[[$(SYSCONFDIR)/config.lua]]" >> src/luarocks/cfg.lua ;\
 	fi
-	if [ "$(ROCKS_TREE)" ] ;\
+	if [ -n "$(ROCKS_TREE)" ] ;\
 	then \
 	   echo "local LUAROCKS_ROCKS_TREE=[[$(ROCKS_TREE)]]" >> src/luarocks/cfg.lua ;\
 	fi
-	if [ "$(FORCE_CONFIG)" ] ;\
+	if [ -n "$(FORCE_CONFIG)" ] ;\
 	then \
 	   echo "local LUAROCKS_FORCE_CONFIG=true" >> src/luarocks/cfg.lua ;\
 	fi
@@ -99,20 +103,20 @@
 	mkdir -p "$(DESTDIR)$(LUADIR)/luarocks"
 	cd src/luarocks && for f in $(LUAROCKS_FILES); do d="$(DESTDIR)$(LUADIR)/luarocks"/`dirname "$$f"`; mkdir -p "$$d"; cp "$$f" "$$d"; done
 	mkdir -p "$(DESTDIR)$(ROCKS_TREE)"
-	if [ ! -e "$(DESTDIR)$(CONFIG_FILE)" ] ;\
+	if [ ! -f "$(DESTDIR)$(CONFIG_FILE)" ] ;\
 	then \
 	   mkdir -p `dirname "$(DESTDIR)$(CONFIG_FILE)"` ;\
 	   echo 'rocks_servers = {' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
 	   echo '   [[http://luarocks.luaforge.net/rocks]]' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
 	   echo '}' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
 	   echo 'rocks_trees = {' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
-	   if ! [ "$(FORCE_CONFIG)" ] ;\
+	   if  [ ! -n "$(FORCE_CONFIG)" ] ;\
 	   then \
 	      echo '   home..[[/.luarocks]],' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
 	   fi ;\
 	   echo '   [[$(ROCKS_TREE)]]' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
 	   echo '}' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
-	   if [ "$(SCRIPTS_DIR)" ] ;\
+	   if [ -n "$(SCRIPTS_DIR)" ] ;\
 	   then \
 	      echo "scripts_dir = [[$(SCRIPTS_DIR)]]" >> "$(DESTDIR)$(CONFIG_FILE)" ;\
 	   fi ;\

## luarocks 2.0.2

=== Makefile ===
# $Id: Makefile,v 1.30 2008/08/18 14:07:35 hisham Exp $

include config.unix

DESTDIR =
PREFIX ?= /usr/local
ROCKS_TREE ?= $(PREFIX)
SYSCONFDIR ?= $(PREFIX)/etc/luarocks
BINDIR ?= $(PREFIX)/bin
LUADIR ?= $(PREFIX)/share/lua/5.1/
LUA_DIR ?= /usr/local
LUA_BINDIR ?= $(LUA_DIR)/bin

BIN_FILES = luarocks luarocks-admin
LUAROCKS_FILES = fs/unix/tools.lua fs/unix.lua fs/win32/tools.lua fs/win32.lua \
fs/lua.lua persist.lua list.lua require.lua rep.lua dir.lua make_manifest.lua \
command_line.lua install.lua build/command.lua build/cmake.lua build/make.lua \
build/builtin.lua fetch/cvs.lua fetch/git.lua fetch/sscm.lua tools/patch.lua \
tools/zip.lua tools/tar.lua pack.lua type_check.lua make.lua path.lua \
remove.lua fs.lua manif.lua add.lua deps.lua build.lua search.lua \
manif_core.lua fetch.lua unpack.lua validate.lua cfg.lua download.lua \
help.lua util.lua index.lua cache.lua add.lua refresh_cache.lua loader.lua

CONFIG_FILE = $(SYSCONFDIR)/config.lua

all: built

src/luarocks/config.lua: config.unix
	rm -f src/luarocks/config.lua
	echo 'module("luarocks.config")' >> src/luarocks/config.lua
	if [ -n "$(PREFIX)" ] ;\
	then \
	   echo "LUAROCKS_PREFIX=[[$(PREFIX)]]" >> src/luarocks/config.lua ;\
	fi
	if [ -n "$(LUA_INCDIR)" ] ;\
	then \
	   echo "LUA_INCDIR=[[$(LUA_INCDIR)]]" >> src/luarocks/config.lua ;\
	fi
	if [ -n "$(LUA_LIBDIR)" ] ;\
	then \
	   echo "LUA_LIBDIR=[[$(LUA_LIBDIR)]]" >> src/luarocks/config.lua ;\
	fi
	if [ -n "$(LUA_BINDIR)" ] ;\
	then \
	   echo "LUA_BINDIR=[[$(LUA_BINDIR)]]" >> src/luarocks/config.lua ;\
	fi
	if [ -n "$(LUA_SUFFIX)" ] ;\
	then \
	   echo "LUA_INTERPRETER=[[lua$(LUA_SUFFIX)]]" >> src/luarocks/config.lua ;\
	fi
	if [ -n "$(SYSCONFDIR)" ] ;\
	then \
	   echo "LUAROCKS_SYSCONFIG=[[$(SYSCONFDIR)/config.lua]]" >> src/luarocks/config.lua ;\
	fi
	if [ -n "$(ROCKS_TREE)" ] ;\
	then \
	   echo "LUAROCKS_ROCKS_TREE=[[$(ROCKS_TREE)]]" >> src/luarocks/config.lua ;\
	fi
	if [ -n "$(FORCE_CONFIG)" ] ;\
	then \
	   echo "LUAROCKS_FORCE_CONFIG=true" >> src/luarocks/config.lua ;\
	fi
	echo "LUAROCKS_UNAME_S=[[$(LUAROCKS_UNAME_S)]]" >> src/luarocks/config.lua
	echo "LUAROCKS_UNAME_M=[[$(LUAROCKS_UNAME_M)]]" >> src/luarocks/config.lua
	echo "LUAROCKS_DOWNLOADER=[[$(LUAROCKS_DOWNLOADER)]]" >> src/luarocks/config.lua
	echo "LUAROCKS_MD5CHECKER=[[$(LUAROCKS_MD5CHECKER)]]" >> src/luarocks/config.lua

build_bins:
	for f in $(BIN_FILES) ;\
	do \
	   sed "1d" src/bin/$$f >> src/bin/$$f.bak ;\
	   echo "#!$(LUA_BINDIR)/lua$(LUA_SUFFIX)" > src/bin/$$f ;\
	   echo "package.path = [[$(LUADIR)/?.lua;$(LUADIR)/?/init.lua;]]..package.path" >> src/bin/$$f ;\
	   cat src/bin/$$f.bak >> src/bin/$$f ;\
	   rm src/bin/$$f.bak ;\
	done

built: src/luarocks/config.lua build_bins
	touch built
	@echo
	@echo "Done. Type 'make install' to install into $(PREFIX)."
	@echo

luadoc:
	rm -rf doc/luadoc
	mkdir -p doc/luadoc
	cd src && luadoc -d ../doc/luadoc --nofiles luarocks/*.lua

check_makefile:
	echo $(BIN_FILES) | tr " " "\n" | sort > makefile_list.txt
	( cd src/bin && ls -d * ) | grep -v "CVS" | sort > luarocks_dir.txt
	echo $(LUAROCKS_FILES) | tr " " "\n" | sort >> makefile_list.txt
	( cd src/luarocks && find * -name "*.lua" ) | sort >> luarocks_dir.txt
	diff makefile_list.txt luarocks_dir.txt
	rm makefile_list.txt luarocks_dir.txt
	@echo
	@echo "Makefile is sane."
	@echo

clean:
	for f in $(BIN_FILES) ;\
	do \
	   sed -i.bak "s,^#!.*lua.*,#!/usr/bin/env lua,;/^package.path/d" src/bin/$$f ;\
	   rm src/bin/$$f.bak ;\
	done
	rm -f src/luarocks/config.lua
	rm -f built

install_bins:
	mkdir -p "$(DESTDIR)$(BINDIR)"
	cd src/bin && cp $(BIN_FILES) "$(DESTDIR)$(BINDIR)"

install_luas:
	mkdir -p "$(DESTDIR)$(LUADIR)/luarocks"
	cd src/luarocks && for f in $(LUAROCKS_FILES); do d="$(DESTDIR)$(LUADIR)/luarocks"/`dirname "$$f"`; mkdir -p "$$d"; cp "$$f" "$$d"; done

install_config:
	mkdir -p "$(DESTDIR)$(LUADIR)/luarocks"
	cd src/luarocks && cp config.lua "$(DESTDIR)$(LUADIR)/luarocks"

write_sysconfig:
	mkdir -p "$(DESTDIR)$(ROCKS_TREE)"
	if [ ! -f "$(DESTDIR)$(CONFIG_FILE)" ] ;\
	then \
	   mkdir -p `dirname "$(DESTDIR)$(CONFIG_FILE)"` ;\
	   echo 'rocks_servers = {' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   echo '   [[http://luarocks.org/repositories/rocks]]' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   echo '}' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   echo 'rocks_trees = {' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   if  [ ! -n "$(FORCE_CONFIG)" ] ;\
	   then \
	      echo '   home..[[/.luarocks]],' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   fi ;\
	   echo '   [[$(ROCKS_TREE)]]' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   echo '}' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	fi

install: built install_bins install_luas install_config write_sysconfig

bootstrap: src/luarocks/config.lua install_config write_sysconfig
	LUA_PATH="$$PWD/src/?.lua;$$LUA_PATH" src/bin/luarocks make rockspec

install_rock: install_bins install_luas

## luarocks 2.0.8

=== Makefile ===
--- 
+++ 
@@ -16,54 +16,58 @@
 fs/lua.lua persist.lua list.lua require.lua rep.lua dir.lua make_manifest.lua \
 command_line.lua install.lua build/command.lua build/cmake.lua build/make.lua \
 build/builtin.lua fetch/cvs.lua fetch/git.lua fetch/sscm.lua tools/patch.lua \
-tools/zip.lua tools/tar.lua pack.lua type_check.lua make.lua path.lua \
-remove.lua fs.lua manif.lua add.lua deps.lua build.lua search.lua \
+fetch/svn.lua tools/zip.lua tools/tar.lua pack.lua type_check.lua make.lua path.lua \
+remove.lua fs.lua manif.lua add.lua deps.lua build.lua search.lua show.lua \
 manif_core.lua fetch.lua unpack.lua validate.lua cfg.lua download.lua \
-help.lua util.lua index.lua cache.lua add.lua refresh_cache.lua loader.lua
+help.lua util.lua index.lua cache.lua add.lua refresh_cache.lua loader.lua \
+admin_remove.lua fetch/hg.lua fetch/git_file.lua
 
 CONFIG_FILE = $(SYSCONFDIR)/config.lua
 
 all: built
 
-src/luarocks/config.lua: config.unix
-	rm -f src/luarocks/config.lua
-	echo 'module("luarocks.config")' >> src/luarocks/config.lua
+src/luarocks/site_config.lua: config.unix
+	rm -f src/luarocks/site_config.lua
+	echo 'module("luarocks.site_config")' >> src/luarocks/site_config.lua
 	if [ -n "$(PREFIX)" ] ;\
 	then \
-	   echo "LUAROCKS_PREFIX=[[$(PREFIX)]]" >> src/luarocks/config.lua ;\
+	   echo "LUAROCKS_PREFIX=[[$(PREFIX)]]" >> src/luarocks/site_config.lua ;\
 	fi
 	if [ -n "$(LUA_INCDIR)" ] ;\
 	then \
-	   echo "LUA_INCDIR=[[$(LUA_INCDIR)]]" >> src/luarocks/config.lua ;\
+	   echo "LUA_INCDIR=[[$(LUA_INCDIR)]]" >> src/luarocks/site_config.lua ;\
 	fi
 	if [ -n "$(LUA_LIBDIR)" ] ;\
 	then \
-	   echo "LUA_LIBDIR=[[$(LUA_LIBDIR)]]" >> src/luarocks/config.lua ;\
+	   echo "LUA_LIBDIR=[[$(LUA_LIBDIR)]]" >> src/luarocks/site_config.lua ;\
 	fi
 	if [ -n "$(LUA_BINDIR)" ] ;\
 	then \
-	   echo "LUA_BINDIR=[[$(LUA_BINDIR)]]" >> src/luarocks/config.lua ;\
+	   echo "LUA_BINDIR=[[$(LUA_BINDIR)]]" >> src/luarocks/site_config.lua ;\
 	fi
 	if [ -n "$(LUA_SUFFIX)" ] ;\
 	then \
-	   echo "LUA_INTERPRETER=[[lua$(LUA_SUFFIX)]]" >> src/luarocks/config.lua ;\
+	   echo "LUA_INTERPRETER=[[lua$(LUA_SUFFIX)]]" >> src/luarocks/site_config.lua ;\
 	fi
 	if [ -n "$(SYSCONFDIR)" ] ;\
 	then \
-	   echo "LUAROCKS_SYSCONFIG=[[$(SYSCONFDIR)/config.lua]]" >> src/luarocks/config.lua ;\
+	   echo "LUAROCKS_SYSCONFIG=[[$(SYSCONFDIR)/config.lua]]" >> src/luarocks/site_config.lua ;\
 	fi
 	if [ -n "$(ROCKS_TREE)" ] ;\
 	then \
-	   echo "LUAROCKS_ROCKS_TREE=[[$(ROCKS_TREE)]]" >> src/luarocks/config.lua ;\
+	   echo "LUAROCKS_ROCKS_TREE=[[$(ROCKS_TREE)]]" >> src/luarocks/site_config.lua ;\
 	fi
 	if [ -n "$(FORCE_CONFIG)" ] ;\
 	then \
-	   echo "LUAROCKS_FORCE_CONFIG=true" >> src/luarocks/config.lua ;\
+	   echo "LUAROCKS_FORCE_CONFIG=true" >> src/luarocks/site_config.lua ;\
 	fi
-	echo "LUAROCKS_UNAME_S=[[$(LUAROCKS_UNAME_S)]]" >> src/luarocks/config.lua
-	echo "LUAROCKS_UNAME_M=[[$(LUAROCKS_UNAME_M)]]" >> src/luarocks/config.lua
-	echo "LUAROCKS_DOWNLOADER=[[$(LUAROCKS_DOWNLOADER)]]" >> src/luarocks/config.lua
-	echo "LUAROCKS_MD5CHECKER=[[$(LUAROCKS_MD5CHECKER)]]" >> src/luarocks/config.lua
+	echo "LUAROCKS_UNAME_S=[[$(LUAROCKS_UNAME_S)]]" >> src/luarocks/site_config.lua
+	echo "LUAROCKS_UNAME_M=[[$(LUAROCKS_UNAME_M)]]" >> src/luarocks/site_config.lua
+	echo "LUAROCKS_DOWNLOADER=[[$(LUAROCKS_DOWNLOADER)]]" >> src/luarocks/site_config.lua
+	echo "LUAROCKS_MD5CHECKER=[[$(LUAROCKS_MD5CHECKER)]]" >> src/luarocks/site_config.lua
+
+dev: cleanup_bins
+	make build_bins LUADIR=$(PWD)/src
 
 build_bins:
 	for f in $(BIN_FILES) ;\
@@ -75,7 +79,7 @@
 	   rm src/bin/$$f.bak ;\
 	done
 
-built: src/luarocks/config.lua build_bins
+built: cleanup_bins src/luarocks/site_config.lua build_bins
 	touch built
 	@echo
 	@echo "Done. Type 'make install' to install into $(PREFIX)."
@@ -97,13 +101,15 @@
 	@echo "Makefile is sane."
 	@echo
 
-clean:
+cleanup_bins:
 	for f in $(BIN_FILES) ;\
 	do \
 	   sed -i.bak "s,^#!.*lua.*,#!/usr/bin/env lua,;/^package.path/d" src/bin/$$f ;\
 	   rm src/bin/$$f.bak ;\
 	done
-	rm -f src/luarocks/config.lua
+
+clean: cleanup_bins
+	rm -f src/luarocks/site_config.lua
 	rm -f built
 
 install_bins:
@@ -114,9 +120,9 @@
 	mkdir -p "$(DESTDIR)$(LUADIR)/luarocks"
 	cd src/luarocks && for f in $(LUAROCKS_FILES); do d="$(DESTDIR)$(LUADIR)/luarocks"/`dirname "$$f"`; mkdir -p "$$d"; cp "$$f" "$$d"; done
 
-install_config:
+install_site_config:
 	mkdir -p "$(DESTDIR)$(LUADIR)/luarocks"
-	cd src/luarocks && cp config.lua "$(DESTDIR)$(LUADIR)/luarocks"
+	cd src/luarocks && cp site_config.lua "$(DESTDIR)$(LUADIR)/luarocks"
 
 write_sysconfig:
 	mkdir -p "$(DESTDIR)$(ROCKS_TREE)"
@@ -135,9 +141,9 @@
 	   echo '}' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
 	fi
 
-install: built install_bins install_luas install_config write_sysconfig
+install: built install_bins install_luas install_site_config write_sysconfig
 
-bootstrap: src/luarocks/config.lua install_config write_sysconfig
+bootstrap: src/luarocks/site_config.lua install_site_config write_sysconfig
 	LUA_PATH="$$PWD/src/?.lua;$$LUA_PATH" src/bin/luarocks make rockspec
 
 install_rock: install_bins install_luas

=== debian/changelog ===
luarocks (2.0.8-2) unstable; urgency=low

  * Clen up luarocks manifest files in postrm script (Closes: #668660)

 -- Enrico Tassi <gareuselesinge@debian.org>  Sun, 15 Apr 2012 14:14:22 +0200

luarocks (2.0.8-1) unstable; urgency=low

  * Moved from CDBS to dh7
  * Source format 3.0 (quilt)
  * Set debian/compat to 7 
  * Bumped standards-version to 3.9.3
  * New upstream release (Closes: #656194)
  * Hardcode lua interpreter to lua5.1 (Closes: #6508660)
  * Probe system at run time calling io.popen('uname') (Closes: #663695)

 -- Enrico Tassi <gareuselesinge@debian.org>  Sat, 24 Mar 2012 19:06:24 +0100

luarocks (2.0.2-1) unstable; urgency=low

  * New upstream release
  * updated debian/rules not to install rcluancher 
  * updated standards version to 3.8.4, no changes 
  * added debian/source/format -- stil 1.0 

 -- Enrico Tassi <gareuselesinge@debian.org>  Tue, 20 Apr 2010 09:34:55 +0200

luarocks (2.0.1-3) unstable; urgency=low

  * create /usr/local/lib/luarocks/rocks during postinst (Closes: #564153) 

 -- Enrico Tassi <gareuselesinge@debian.org>  Tue, 12 Jan 2010 23:41:05 +0100

luarocks (2.0.1-2) unstable; urgency=low

  * do not install empty directory /usr/lib/luarocks (Closes: #555008)
  * run luarocks-admin make_manifest in postinst (Closes: #555007) 

 -- Enrico Tassi <gareuselesinge@debian.org>  Sun, 08 Nov 2009 00:01:44 +0100

luarocks (2.0.1-1) unstable; urgency=low

  [ Duboucher Thomas ]
  * new upstream release
  * updated watch to http://www.luarocks.org/releases/
  * changed lua to Lua in package description 
  * changed luarocks to LuaRocks in package description 

  [ Enrico Tassi ]
  * bumped standards-version to 3.8.3, no changes 
  * install rocks in /usr/local
  * added manpages for luarocks and luarocks-admin

 -- Enrico Tassi <gareuselesinge@debian.org>  Sun, 01 Nov 2009 17:33:21 +0100

luarocks (1.0.1-1) unstable; urgency=low

  * new upstream release
  * added misc:Depends to Depends:
  * bumped standards-version to 3.8.1, no changes needed
  * added dependency over zip package (Closes: #497830)

 -- Enrico Tassi <gareuselesinge@debian.org>  Mon, 23 Mar 2009 11:14:11 +0100

luarocks (1.0-2) unstable; urgency=low

  * upload to unstable

 -- Enrico Tassi <gareuselesinge@debian.org>  Sun, 15 Mar 2009 10:23:03 +0100

luarocks (1.0-1) experimental; urgency=low

  * New upstream release
  * Bumped Standards-Version to 3.8.0, no changes needed 

 -- Enrico Tassi <gareuselesinge@debian.org>  Wed, 03 Sep 2008 18:02:21 +0200

luarocks (0.6.0.2-1) unstable; urgency=low

  * New upstream release

 -- Enrico Tassi <gareuselesinge@debian.org>  Wed, 02 Jul 2008 10:22:44 +0200

luarocks (0.5.2-1) unstable; urgency=low

  * New upstream release

 -- Enrico Tassi <gareuselesinge@debian.org>  Wed, 14 May 2008 11:55:11 +0200

luarocks (0.5.1-1) unstable; urgency=low

  * New upstream release featuring minor bugfixes

 -- Enrico Tassi <gareuselesinge@debian.org>  Sat, 26 Apr 2008 11:52:15 +0200

luarocks (0.5-1) unstable; urgency=low

  * New upstream release

 -- Enrico Tassi <gareuselesinge@debian.org>  Fri, 04 Apr 2008 10:57:58 +0200

luarocks (0.4.3-2) unstable; urgency=low

  * Added build dependency on liblua5.1-dev, that is not actually used, but
    the configure script checks its existence (Closes: #470267)

 -- Enrico Tassi <gareuselesinge@debian.org>  Mon, 10 Mar 2008 13:17:03 +0100

luarocks (0.4.3-1) unstable; urgency=low

  * Initial release. (Closes: #465124)

 -- Enrico Tassi <gareuselesinge@debian.org>  Mon, 03 Mar 2008 23:40:03 +0100

## luarocks 2.0.9

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 ROCKS_TREE ?= $(PREFIX)
 SYSCONFDIR ?= $(PREFIX)/etc/luarocks
 BINDIR ?= $(PREFIX)/bin
-LUADIR ?= $(PREFIX)/share/lua/5.1/
+LUADIR ?= $(PREFIX)/share/lua/$(LUA_VERSION)/
 LUA_DIR ?= /usr/local
 LUA_BINDIR ?= $(LUA_DIR)/bin
 
@@ -20,7 +20,7 @@
 remove.lua fs.lua manif.lua add.lua deps.lua build.lua search.lua show.lua \
 manif_core.lua fetch.lua unpack.lua validate.lua cfg.lua download.lua \
 help.lua util.lua index.lua cache.lua add.lua refresh_cache.lua loader.lua \
-admin_remove.lua fetch/hg.lua fetch/git_file.lua
+admin_remove.lua fetch/hg.lua fetch/git_file.lua new_version.lua
 
 CONFIG_FILE = $(SYSCONFDIR)/config.lua
 
@@ -66,20 +66,21 @@
 	echo "LUAROCKS_DOWNLOADER=[[$(LUAROCKS_DOWNLOADER)]]" >> src/luarocks/site_config.lua
 	echo "LUAROCKS_MD5CHECKER=[[$(LUAROCKS_MD5CHECKER)]]" >> src/luarocks/site_config.lua
 
-dev: cleanup_bins
-	make build_bins LUADIR=$(PWD)/src
+dev:
+	$(MAKE) build_bins LUADIR=$(PWD)/src
 
-build_bins:
+build_bins: cleanup_bins
 	for f in $(BIN_FILES) ;\
 	do \
-	   sed "1d" src/bin/$$f >> src/bin/$$f.bak ;\
+	   sed "1d" src/bin/$$f > src/bin/$$f.bak ;\
 	   echo "#!$(LUA_BINDIR)/lua$(LUA_SUFFIX)" > src/bin/$$f ;\
 	   echo "package.path = [[$(LUADIR)/?.lua;$(LUADIR)/?/init.lua;]]..package.path" >> src/bin/$$f ;\
 	   cat src/bin/$$f.bak >> src/bin/$$f ;\
-	   rm src/bin/$$f.bak ;\
+	   chmod +x src/bin/$$f ;\
+	   rm -f src/bin/$$f.bak ;\
 	done
 
-built: cleanup_bins src/luarocks/site_config.lua build_bins
+built: src/luarocks/site_config.lua build_bins
 	touch built
 	@echo
 	@echo "Done. Type 'make install' to install into $(PREFIX)."
@@ -96,7 +97,7 @@
 	echo $(LUAROCKS_FILES) | tr " " "\n" | sort >> makefile_list.txt
 	( cd src/luarocks && find * -name "*.lua" ) | sort >> luarocks_dir.txt
 	diff makefile_list.txt luarocks_dir.txt
-	rm makefile_list.txt luarocks_dir.txt
+	rm -f makefile_list.txt luarocks_dir.txt
 	@echo
 	@echo "Makefile is sane."
 	@echo
@@ -104,27 +105,29 @@
 cleanup_bins:
 	for f in $(BIN_FILES) ;\
 	do \
-	   sed -i.bak "s,^#!.*lua.*,#!/usr/bin/env lua,;/^package.path/d" src/bin/$$f ;\
-	   rm src/bin/$$f.bak ;\
+	   mv src/bin/$$f src/bin/$$f.bak ;\
+	   sed "s,^#!.*lua.*,#!/usr/bin/env lua,;/^package.path/d" < src/bin/$$f.bak > src/bin/$$f ;\
+	   chmod +x src/bin/$$f ;\
+	   rm -f src/bin/$$f.bak ;\
 	done
 
 clean: cleanup_bins
 	rm -f src/luarocks/site_config.lua
 	rm -f built
 
-install_bins:
+install_bins: built
 	mkdir -p "$(DESTDIR)$(BINDIR)"
 	cd src/bin && cp $(BIN_FILES) "$(DESTDIR)$(BINDIR)"
 
-install_luas:
+install_luas: built
 	mkdir -p "$(DESTDIR)$(LUADIR)/luarocks"
 	cd src/luarocks && for f in $(LUAROCKS_FILES); do d="$(DESTDIR)$(LUADIR)/luarocks"/`dirname "$$f"`; mkdir -p "$$d"; cp "$$f" "$$d"; done
 
-install_site_config:
+install_site_config: built
 	mkdir -p "$(DESTDIR)$(LUADIR)/luarocks"
 	cd src/luarocks && cp site_config.lua "$(DESTDIR)$(LUADIR)/luarocks"
 
-write_sysconfig:
+write_sysconfig: built
 	mkdir -p "$(DESTDIR)$(ROCKS_TREE)"
 	if [ ! -f "$(DESTDIR)$(CONFIG_FILE)" ] ;\
 	then \
@@ -141,7 +144,7 @@
 	   echo '}' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
 	fi
 
-install: built install_bins install_luas install_site_config write_sysconfig
+install: install_bins install_luas install_site_config write_sysconfig
 
 bootstrap: src/luarocks/site_config.lua install_site_config write_sysconfig
 	LUA_PATH="$$PWD/src/?.lua;$$LUA_PATH" src/bin/luarocks make rockspec

=== debian/changelog ===
luarocks (2.0.9-1) unstable; urgency=low

  * New upstream release with some support for Lua 5.2

 -- Enrico Tassi <gareuselesinge@debian.org>  Sun, 15 Apr 2012 14:19:13 +0200

=== debian/control ===
Source: luarocks
Section: interpreters
Priority: optional
Maintainer: Enrico Tassi <gareuselesinge@debian.org>
Build-Depends: debhelper (>= 8), luadoc, liblua5.1-dev, wget, txt2man
Standards-Version: 3.9.3
Vcs-Svn: svn://svn.debian.org/pkg-lua/packages/luarocks
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-lua/packages/luarocks
Homepage: http://luarocks.org/

Package: luarocks
Architecture: all
Depends: lua5.1, liblua5.1-dev, wget, ${misc:Depends}, zip
Description: deployment and management system for Lua modules
 This package contains LuaRocks, a tool for managing rocks.  A Lua rock is a
 bundle containing a module and some metadata like compilation instructions and
 copyright. The command line utility luarocks can download, build, install and
 remove rocks, properly handling dependencies among them and allowing multiple
 versions of the same rock to coexist. 
 .
 The tool installs system-wide rocks in /usr/local when run by the superuser,
 but a regular user can easily tune it to install rocks in his home directory.
 .
 This package also provides the luarocks-admin tool, needed to create a rocks
 repository, and the documentation for luarocks, describing the command line
 tools as well as the library to manipulate rocks.

=== debian/rules ===
#!/usr/bin/make -f

DEB_DESTDIR=debian/tmp

%:
	dh $@

override_dh_auto_configure:
	./configure \
 		--prefix=/usr \
 		--sysconfdir=/etc/luarocks \
 		--with-lua=/usr \
 		--with-lua-include=/usr/include/lua5.1 \
 		--with-lua-lib=/usr/local/lib \
		--rocks-tree=/usr/local/ \
		--with-downloader=wget \
		--with-md5-checker=md5sum

override_dh_auto_build:
	make
	txt2man -t "luarocks 1" -r "LuaRocks" -v "" debian/luarocks.1.txt \
		> luarocks.1
	txt2man -t "luarocks-admin 1" -r "LuaRocks repository administration"\
	       	-v "" debian/luarocks-admin.1.txt > luarocks-admin.1

override_dh_auto_install:
	mkdir -p $(DEB_DESTDIR)/etc/luarocks/
	mkdir -p $(DEB_DESTDIR)/usr/bin/
	mkdir -p $(DEB_DESTDIR)/usr/share/lua/5.1/
	mkdir -p $(DEB_DESTDIR)/usr/share/doc/luarocks/doc/
	cp -r src/luarocks $(DEB_DESTDIR)/usr/share/lua/5.1/
	sed -i -e '1i\local popen = io.popen' $(DEB_DESTDIR)/usr/share/lua/5.1/luarocks/site_config.lua
	sed -i -e 's/^LUAROCKS_UNAME_S.*/LUAROCKS_UNAME_S=(popen("uname -s"):read("*a"):gsub("\\n",""))/' $(DEB_DESTDIR)/usr/share/lua/5.1/luarocks/site_config.lua
	sed -i -e 's/^LUAROCKS_UNAME_M.*/LUAROCKS_UNAME_M=(popen("uname -m"):read("*a"):gsub("\\n",""))/' $(DEB_DESTDIR)/usr/share/lua/5.1/luarocks/site_config.lua
	cp src/bin/luarocks $(DEB_DESTDIR)/usr/bin/
	cp src/bin/luarocks-admin $(DEB_DESTDIR)/usr/bin/
	sed -i -e '1c\#!/usr/bin/env lua5.1' $(DEB_DESTDIR)/usr/bin/*
	make luadoc
	cp -r doc/luadoc/* $(DEB_DESTDIR)/usr/share/doc/luarocks/doc/
	echo 'rocks_servers = {' > $(DEB_DESTDIR)/etc/luarocks/config.lua
	echo '   [[http://luarocks.org/repositories/rocks]]' >> $(DEB_DESTDIR)/etc/luarocks/config.lua
	echo '}' >> $(DEB_DESTDIR)/etc/luarocks/config.lua
	echo '' >> $(DEB_DESTDIR)/etc/luarocks/config.lua
	echo 'rocks_trees = {' >> $(DEB_DESTDIR)/etc/luarocks/config.lua
	echo '   home..[[/.luarocks]],' >> $(DEB_DESTDIR)/etc/luarocks/config.lua
	echo '   [[/usr/local]]' >> $(DEB_DESTDIR)/etc/luarocks/config.lua
	echo '}' >> $(DEB_DESTDIR)/etc/luarocks/config.lua

override_dh_auto_clean:
	rm -f luarocks.1 luarocks-admin.1
	make clean || true

=== debian/watch ===
# test this watch file using:
# uscan --watchfile debian/watch --upstream-version 0.0.1 --package luarocks
#
version=3
http://www.luarocks.org/releases/luarocks-([\d\.]*).tar.gz

## luarocks 2.2.0%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: interpreters
 Priority: optional
 Maintainer: Enrico Tassi <gareuselesinge@debian.org>
-Build-Depends: debhelper (>= 8), luadoc, liblua5.1-dev, wget, txt2man
+Build-Depends: debhelper (>= 8), lua-ldoc, lua5.1, liblua5.1-dev, wget, txt2man
 Standards-Version: 3.9.3
 Vcs-Svn: svn://svn.debian.org/pkg-lua/packages/luarocks
 Vcs-Browser: http://svn.debian.org/viewsvn/pkg-lua/packages/luarocks

## luarocks 2.2.0+dfsg

=== Makefile ===

include config.unix

.PHONY: all build dev build_bins luadoc check_makefile cleanup_bins clean \
 install_bins install_luas install_site_config write_sysconfig \
 install bootstrap install_rock

DESTDIR =
PREFIX ?= /usr/local
ROCKS_TREE ?= $(PREFIX)
SYSCONFDIR ?= $(PREFIX)/etc/luarocks
BINDIR ?= $(PREFIX)/bin
LUADIR ?= $(PREFIX)/share/lua/$(LUA_VERSION)/
LUA_DIR ?= /usr/local
LUA_BINDIR ?= $(LUA_DIR)/bin

BIN_FILES = luarocks luarocks-admin
LUAROCKS_FILES = fs/unix/tools.lua fs/unix.lua fs/win32/tools.lua fs/win32.lua \
fs/lua.lua persist.lua list.lua require.lua repos.lua dir.lua make_manifest.lua \
command_line.lua install.lua build/command.lua build/cmake.lua build/make.lua \
build/builtin.lua fetch/cvs.lua fetch/git.lua fetch/sscm.lua tools/patch.lua \
fetch/svn.lua tools/zip.lua tools/tar.lua pack.lua type_check.lua make.lua \
remove.lua fs.lua manif.lua add.lua deps.lua build.lua search.lua show.lua \
manif_core.lua fetch.lua unpack.lua validate.lua cfg.lua download.lua \
help.lua util.lua index.lua cache.lua refresh_cache.lua loader.lua \
admin_remove.lua fetch/hg.lua fetch/git_file.lua new_version.lua lint.lua \
purge.lua path.lua path_cmd.lua write_rockspec.lua doc.lua upload.lua \
upload/api.lua upload/multipart.lua fetch/git_http.lua

CONFIG_FILE = $(SYSCONFDIR)/config-$(LUA_VERSION).lua

SAFEPWD=`echo "$$PWD" | sed -e 's/\([][]\)\1/]]..'\''\1\1'\''..[[/g'`

all: 
	@echo "- Type 'make build' and 'make install':"
	@echo "  to install to $(PREFIX) as usual."
	@echo "- Type 'make bootstrap':"
	@echo "  to install LuaRocks in $(PREFIX) as a rock."
	@echo

build: src/luarocks/site_config.lua build_bins
	@echo
	@echo "Done. Type 'make install' to install into $(PREFIX)."
	@echo

src/luarocks/site_config.lua: config.unix
	rm -f src/luarocks/site_config.lua
	echo 'local site_config = {}' >> src/luarocks/site_config.lua
	if [ -n "$(PREFIX)" ] ;\
	then \
	   echo "site_config.LUAROCKS_PREFIX=[[$(PREFIX)]]" >> src/luarocks/site_config.lua ;\
	fi
	if [ -n "$(LUA_INCDIR)" ] ;\
	then \
	   echo "site_config.LUA_INCDIR=[[$(LUA_INCDIR)]]" >> src/luarocks/site_config.lua ;\
	fi
	if [ -n "$(LUA_LIBDIR)" ] ;\
	then \
	   echo "site_config.LUA_LIBDIR=[[$(LUA_LIBDIR)]]" >> src/luarocks/site_config.lua ;\
	fi
	if [ -n "$(LUA_BINDIR)" ] ;\
	then \
	   echo "site_config.LUA_BINDIR=[[$(LUA_BINDIR)]]" >> src/luarocks/site_config.lua ;\
	fi
	if [ -n "$(LUA_SUFFIX)" ] ;\
	then \
	   echo "site_config.LUA_INTERPRETER=[[lua$(LUA_SUFFIX)]]" >> src/luarocks/site_config.lua ;\
	fi
	if [ -n "$(SYSCONFDIR)" ] ;\
	then \
	   echo "site_config.LUAROCKS_SYSCONFDIR=[[$(SYSCONFDIR)]]" >> src/luarocks/site_config.lua ;\
	fi
	if [ -n "$(ROCKS_TREE)" ] ;\
	then \
	   echo "site_config.LUAROCKS_ROCKS_TREE=[[$(ROCKS_TREE)]]" >> src/luarocks/site_config.lua ;\
	fi
	if [ -n "$(FORCE_CONFIG)" ] ;\
	then \
	   echo "site_config.LUAROCKS_FORCE_CONFIG=true" >> src/luarocks/site_config.lua ;\
	fi
	if [ -n "$(LUAROCKS_ROCKS_SUBDIR)" ] ;\
	then \
	   echo "site_config.LUAROCKS_ROCKS_SUBDIR=[[$(LUAROCKS_ROCKS_SUBDIR)]]" >> src/luarocks/site_config.lua ;\
	fi
	if [ "$(LUA_DIR_SET)" = "yes" ] ;\
	then \
	   echo "site_config.LUA_DIR_SET=true" >> src/luarocks/site_config.lua ;\
	fi
	echo "site_config.LUAROCKS_UNAME_S=[[$(LUAROCKS_UNAME_S)]]" >> src/luarocks/site_config.lua
	echo "site_config.LUAROCKS_UNAME_M=[[$(LUAROCKS_UNAME_M)]]" >> src/luarocks/site_config.lua
	echo "site_config.LUAROCKS_DOWNLOADER=[[$(LUAROCKS_DOWNLOADER)]]" >> src/luarocks/site_config.lua
	echo "site_config.LUAROCKS_MD5CHECKER=[[$(LUAROCKS_MD5CHECKER)]]" >> src/luarocks/site_config.lua
	if [ -n "$(MULTIARCH_SUBDIR)" ] ;\
	then \
	   echo 'site_config.LUAROCKS_EXTERNAL_DEPS_SUBDIRS={ bin="bin", lib={ "lib", [[$(MULTIARCH_SUBDIR)]] }, include="include" }' >> src/luarocks/site_config.lua ;\
	   echo 'site_config.LUAROCKS_RUNTIME_EXTERNAL_DEPS_SUBDIRS={ bin="bin", lib={ "lib", [[$(MULTIARCH_SUBDIR)]] }, include="include" }' >> src/luarocks/site_config.lua ;\
	fi
	echo "return site_config" >> src/luarocks/site_config.lua

dev:
	$(MAKE) build_bins LUADIR=$(PWD)/src

build_bins: cleanup_bins
	for f in $(BIN_FILES) ;\
	do \
	   sed "1d" src/bin/$$f > src/bin/$$f.bak ;\
	   echo "#!$(LUA_BINDIR)/lua$(LUA_SUFFIX)" > src/bin/$$f ;\
	   echo "package.path = [[$(LUADIR)/?.lua;]]..package.path" | sed "s,//,/,g" >> src/bin/$$f ;\
	   cat src/bin/$$f.bak >> src/bin/$$f ;\
	   chmod +x src/bin/$$f ;\
	   rm -f src/bin/$$f.bak ;\
	done

luadoc:
	rm -rf doc/luadoc
	mkdir -p doc/luadoc
	cd src && luadoc -d ../doc/luadoc --nofiles luarocks/*.lua

check_makefile: clean
	echo $(BIN_FILES) | tr " " "\n" | sort > makefile_list.txt
	( cd src/bin && ls -d * ) | sort > luarocks_dir.txt
	echo $(LUAROCKS_FILES) | tr " " "\n" | sort >> makefile_list.txt
	( cd src/luarocks && find * -name "*.lua" ) | sort >> luarocks_dir.txt
	diff makefile_list.txt luarocks_dir.txt
	rm -f makefile_list.txt luarocks_dir.txt
	@echo
	@echo "Makefile is sane."
	@echo

cleanup_bins:
	for f in $(BIN_FILES) ;\
	do \
	   mv src/bin/$$f src/bin/$$f.bak ;\
	   sed "s,^#!.*lua.*,#!/usr/bin/env lua,;/^package.path/d" < src/bin/$$f.bak > src/bin/$$f ;\
	   chmod +x src/bin/$$f ;\
	   rm -f src/bin/$$f.bak ;\
	done

clean: cleanup_bins
	rm -f src/luarocks/site_config.lua

install_bins:
	mkdir -p "$(DESTDIR)$(BINDIR)"
	cd src/bin && for f in $(BIN_FILES); \
	do \
	   cp "$$f" "$(DESTDIR)$(BINDIR)/$$f-$(LUA_VERSION)"; \
	   ln -nfs "$$f-$(LUA_VERSION)" "$(DESTDIR)$(BINDIR)/$$f"; \
	done

install_luas:
	mkdir -p "$(DESTDIR)$(LUADIR)/luarocks"
	cd src/luarocks && for f in $(LUAROCKS_FILES); \
	do \
	   d="$(DESTDIR)$(LUADIR)/luarocks"/`dirname "$$f"` && \
	   mkdir -p "$$d" && \
	   cp "$$f" "$$d" || exit 1; \
	done

install_site_config: src/luarocks/site_config.lua
	mkdir -p "$(DESTDIR)$(LUADIR)/luarocks"
	cp src/luarocks/site_config.lua "$(DESTDIR)$(LUADIR)/luarocks"

write_sysconfig:
	mkdir -p "$(DESTDIR)$(ROCKS_TREE)"
	if [ ! -f "$(DESTDIR)$(CONFIG_FILE)" ] ;\
	then \
	   mkdir -p `dirname "$(DESTDIR)$(CONFIG_FILE)"` ;\
	   echo 'rocks_trees = {' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   if  [ ! -n "$(FORCE_CONFIG)" ] ;\
	   then \
	      echo '   { name = [[user]], root = home..[[/.luarocks]] },' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   fi ;\
	   echo '   { name = [[system]], root = [[$(ROCKS_TREE)]] }' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	   echo '}' >> "$(DESTDIR)$(CONFIG_FILE)" ;\
	fi

install: install_bins install_luas install_site_config write_sysconfig

bootstrap: src/luarocks/site_config.lua install_site_config write_sysconfig cleanup_bins
	'$(LUA_BINDIR)/lua$(LUA_SUFFIX)' -e "package.path=[[$(SAFEPWD)/src/?.lua;]]..package.path" src/bin/luarocks make rockspec --tree="$(PREFIX)"

install_rock: install_bins install_luas

=== debian/changelog ===
luarocks (2.2.0+dfsg-2) unstable; urgency=medium

  * Build depend on lua5.1 explicitly (Close: 796443) 

 -- Enrico Tassi <gareuselesinge@debian.org>  Sat, 22 Aug 2015 17:48:25 +0200

luarocks (2.2.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * patch 0001-Fixed-detection-of-Debian-paths removed (applied upstream)

 -- Enrico Tassi <gareuselesinge@debian.org>  Sat, 11 Oct 2014 15:26:47 +0200

luarocks (2.0.12-2) unstable; urgency=low

  * Add to the config file the correct multiarch path for system
    wide libraries (Closes: #724509)

 -- Enrico Tassi <gareuselesinge@debian.org>  Tue, 24 Sep 2013 22:31:04 +0200

luarocks (2.0.12-1) unstable; urgency=low

  * New upstream release 
  * Cherry-pick upstream patch for Debian paths 

 -- Enrico Tassi <gareuselesinge@debian.org>  Sun, 09 Jun 2013 17:50:48 +0200

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,7 @@
 
 override_dh_auto_configure:
 	./configure \
+		--lua-version=5.1 \
  		--prefix=/usr \
  		--sysconfdir=/etc/luarocks \
  		--with-lua=/usr \
@@ -17,12 +18,19 @@
 		--with-md5-checker=md5sum
 
 override_dh_auto_build:
-	make
+	make build
 	txt2man -t "luarocks 1" -r "LuaRocks" -v "" debian/luarocks.1.txt \
 		> luarocks.1
 	txt2man -t "luarocks-admin 1" -r "LuaRocks repository administration"\
 	       	-v "" debian/luarocks-admin.1.txt > luarocks-admin.1
 
+define LUAROCKS_CONF
+rocks_trees = {
+   home..[[/.luarocks]],
+   [[/usr/local]]
+}
+endef
+export LUAROCKS_CONF
 override_dh_auto_install:
 	mkdir -p $(DEB_DESTDIR)/etc/luarocks/
 	mkdir -p $(DEB_DESTDIR)/usr/bin/
@@ -35,16 +43,7 @@
 	cp src/bin/luarocks $(DEB_DESTDIR)/usr/bin/
 	cp src/bin/luarocks-admin $(DEB_DESTDIR)/usr/bin/
 	sed -i -e '1c\#!/usr/bin/env lua5.1' $(DEB_DESTDIR)/usr/bin/*
-	make luadoc
-	cp -r doc/luadoc/* $(DEB_DESTDIR)/usr/share/doc/luarocks/doc/
-	echo 'rocks_servers = {' > $(DEB_DESTDIR)/etc/luarocks/config.lua
-	echo '   [[http://luarocks.org/repositories/rocks]]' >> $(DEB_DESTDIR)/etc/luarocks/config.lua
-	echo '}' >> $(DEB_DESTDIR)/etc/luarocks/config.lua
-	echo '' >> $(DEB_DESTDIR)/etc/luarocks/config.lua
-	echo 'rocks_trees = {' >> $(DEB_DESTDIR)/etc/luarocks/config.lua
-	echo '   home..[[/.luarocks]],' >> $(DEB_DESTDIR)/etc/luarocks/config.lua
-	echo '   [[/usr/local]]' >> $(DEB_DESTDIR)/etc/luarocks/config.lua
-	echo '}' >> $(DEB_DESTDIR)/etc/luarocks/config.lua
+	echo "$$LUAROCKS_CONF" > $(DEB_DESTDIR)/etc/luarocks/config-5.1.lua
 
 override_dh_auto_clean:
 	rm -f luarocks.1 luarocks-admin.1

=== debian/watch ===
# test this watch file using:
# uscan --watchfile debian/watch --upstream-version 0.0.1 --package luarocks
#
version=3
opts=dversionmangle=s/\+dfsg\d*$// \
  http://www.luarocks.org/releases/luarocks-([\d\.]*).tar.gz

## luarocks 2.4.2+dfsg

=== Makefile ===
--- 
+++ 
@@ -2,30 +2,13 @@
 include config.unix
 
 .PHONY: all build dev build_bins luadoc check_makefile cleanup_bins clean \
- install_bins install_luas install_site_config write_sysconfig \
- install bootstrap install_rock
+ install_site_config write_sysconfig install bootstrap install_rock \
+ run_luarocks
 
-DESTDIR =
-PREFIX ?= /usr/local
 ROCKS_TREE ?= $(PREFIX)
 SYSCONFDIR ?= $(PREFIX)/etc/luarocks
-BINDIR ?= $(PREFIX)/bin
-LUADIR ?= $(PREFIX)/share/lua/$(LUA_VERSION)/
 LUA_DIR ?= /usr/local
 LUA_BINDIR ?= $(LUA_DIR)/bin
-
-BIN_FILES = luarocks luarocks-admin
-LUAROCKS_FILES = fs/unix/tools.lua fs/unix.lua fs/win32/tools.lua fs/win32.lua \
-fs/lua.lua persist.lua list.lua require.lua repos.lua dir.lua make_manifest.lua \
-command_line.lua install.lua build/command.lua build/cmake.lua build/make.lua \
-build/builtin.lua fetch/cvs.lua fetch/git.lua fetch/sscm.lua tools/patch.lua \
-fetch/svn.lua tools/zip.lua tools/tar.lua pack.lua type_check.lua make.lua \
-remove.lua fs.lua manif.lua add.lua deps.lua build.lua search.lua show.lua \
-manif_core.lua fetch.lua unpack.lua validate.lua cfg.lua download.lua \
-help.lua util.lua index.lua cache.lua refresh_cache.lua loader.lua \
-admin_remove.lua fetch/hg.lua fetch/git_file.lua new_version.lua lint.lua \
-purge.lua path.lua path_cmd.lua write_rockspec.lua doc.lua upload.lua \
-upload/api.lua upload/multipart.lua fetch/git_http.lua
 
 CONFIG_FILE = $(SYSCONFDIR)/config-$(LUA_VERSION).lua
 
@@ -37,6 +20,9 @@
 	@echo "- Type 'make bootstrap':"
 	@echo "  to install LuaRocks in $(PREFIX) as a rock."
 	@echo
+
+include Makefile.setup.inc
+include Makefile.install.inc
 
 build: src/luarocks/site_config.lua build_bins
 	@echo
@@ -107,7 +93,7 @@
 	   echo "#!$(LUA_BINDIR)/lua$(LUA_SUFFIX)" > src/bin/$$f ;\
 	   echo "package.path = [[$(LUADIR)/?.lua;]]..package.path" | sed "s,//,/,g" >> src/bin/$$f ;\
 	   cat src/bin/$$f.bak >> src/bin/$$f ;\
-	   chmod +x src/bin/$$f ;\
+	   chmod +rx src/bin/$$f ;\
 	   rm -f src/bin/$$f.bak ;\
 	done
 
@@ -132,29 +118,15 @@
 	do \
 	   mv src/bin/$$f src/bin/$$f.bak ;\
 	   sed "s,^#!.*lua.*,#!/usr/bin/env lua,;/^package.path/d" < src/bin/$$f.bak > src/bin/$$f ;\
-	   chmod +x src/bin/$$f ;\
+	   chmod +rx src/bin/$$f ;\
 	   rm -f src/bin/$$f.bak ;\
 	done
 
 clean: cleanup_bins
 	rm -f src/luarocks/site_config.lua
 
-install_bins:
-	mkdir -p "$(DESTDIR)$(BINDIR)"
-	cd src/bin && for f in $(BIN_FILES); \
-	do \
-	   cp "$$f" "$(DESTDIR)$(BINDIR)/$$f-$(LUA_VERSION)"; \
-	   ln -nfs "$$f-$(LUA_VERSION)" "$(DESTDIR)$(BINDIR)/$$f"; \
-	done
-
-install_luas:
-	mkdir -p "$(DESTDIR)$(LUADIR)/luarocks"
-	cd src/luarocks && for f in $(LUAROCKS_FILES); \
-	do \
-	   d="$(DESTDIR)$(LUADIR)/luarocks"/`dirname "$$f"` && \
-	   mkdir -p "$$d" && \
-	   cp "$$f" "$$d" || exit 1; \
-	done
+run_luarocks:
+	'$(LUA_BINDIR)/lua$(LUA_SUFFIX)' -e "package.path=[[$(SAFEPWD)/src/?.lua;]]..package.path" src/bin/luarocks make rockspec --tree="$(PREFIX)"
 
 install_site_config: src/luarocks/site_config.lua
 	mkdir -p "$(DESTDIR)$(LUADIR)/luarocks"
@@ -176,7 +148,7 @@
 
 install: install_bins install_luas install_site_config write_sysconfig
 
-bootstrap: src/luarocks/site_config.lua install_site_config write_sysconfig cleanup_bins
-	'$(LUA_BINDIR)/lua$(LUA_SUFFIX)' -e "package.path=[[$(SAFEPWD)/src/?.lua;]]..package.path" src/bin/luarocks make rockspec --tree="$(PREFIX)"
+bootstrap: src/luarocks/site_config.lua run_luarocks install_site_config write_sysconfig cleanup_bins
 
 install_rock: install_bins install_luas
+

=== debian/changelog ===
luarocks (2.4.2+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Support lua 5.1, 5.2 and 5.3 via lua-any
  * Recommend lua-sec for https download 

 -- Enrico Tassi <gareuselesinge@debian.org>  Mon, 26 Dec 2016 10:15:35 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: interpreters
 Priority: optional
 Maintainer: Enrico Tassi <gareuselesinge@debian.org>
-Build-Depends: debhelper (>= 8), lua-ldoc, lua5.1, liblua5.1-dev, wget, txt2man
+Build-Depends: debhelper (>= 8), lua-ldoc, lua5.1, liblua5.1-dev, wget, txt2man, unzip, dh-lua
 Standards-Version: 3.9.3
 Vcs-Svn: svn://svn.debian.org/pkg-lua/packages/luarocks
 Vcs-Browser: http://svn.debian.org/viewsvn/pkg-lua/packages/luarocks
@@ -10,7 +10,8 @@
 
 Package: luarocks
 Architecture: all
-Depends: lua5.1, liblua5.1-dev, wget, ${misc:Depends}, zip
+Depends: lua-any, lua5.1 | lua5.2 | lua5.3, liblua5.1-dev | liblua5.2-dev | liblua5.3-dev, wget, ${misc:Depends}, zip, unzip
+Recommends: lua-sec
 Description: deployment and management system for Lua modules
  This package contains LuaRocks, a tool for managing rocks.  A Lua rock is a
  bundle containing a module and some metadata like compilation instructions and

## luarocks 3.7.0+dfsg1

=== debian/changelog ===
luarocks (3.7.0+dfsg1-1ubuntu1) jammy; urgency=medium

  * d/luarocks.postinst: Add global flag to fix installation (LP: #1949957).
  * d/tests: Add basic autopkgtests.

 -- Chris MacNaughton <chris.macnaughton@ubuntu.com>  Fri, 05 Nov 2021 14:01:10 +0000

luarocks (3.7.0+dfsg1-1) unstable; urgency=medium

  * New upstream release (Closes: #909394, #930257, #995240)
  * Add local-tree to luarocks-admin
  * AMAU, lua-team maintenance
  * Standards-Version 4.5.1
  * Update Vcs fields
  * Use watch file version 4
  * Exclude binary/ files
  * Update copyright to format 1.0
  * Fix stars in NEWS
  * Less intervention for luarocks paths resolution
  * debhelper 13

 -- Jérémy Lal <kapouer@melix.org>  Tue, 28 Sep 2021 17:01:22 +0200

luarocks (2.4.2+dfsg-1.1) unstable; urgency=medium

  * Non maintainer upload by the Reproducible Builds team.
  * No source change upload to rebuild on buildd with .buildinfo files.

 -- Holger Levsen <holger@debian.org>  Sat, 02 Jan 2021 00:36:28 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,14 @@
 Source: luarocks
 Section: interpreters
 Priority: optional
-Maintainer: Enrico Tassi <gareuselesinge@debian.org>
-Build-Depends: debhelper (>= 8), lua-ldoc, lua5.1, liblua5.1-dev, wget, txt2man, unzip, dh-lua
-Standards-Version: 3.9.3
-Vcs-Svn: svn://svn.debian.org/pkg-lua/packages/luarocks
-Vcs-Browser: http://svn.debian.org/viewsvn/pkg-lua/packages/luarocks
-Homepage: http://luarocks.org/
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
+Uploaders: Jérémy Lal <kapouer@melix.org>
+Build-Depends: debhelper-compat (= 13), lua-ldoc, lua5.1, liblua5.1-dev, wget, txt2man, unzip, dh-lua
+Standards-Version: 4.5.1
+Vcs-Browser: https://salsa.debian.org/lua-team/luarocks
+Vcs-Git: https://salsa.debian.org/lua-team/luarocks.git
+Homepage: https://luarocks.org/
 
 Package: luarocks
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

DEB_DESTDIR=debian/tmp

%:
	dh $@

override_dh_auto_configure:
	./configure \
		--lua-version=5.1 \
 		--prefix=/usr \
 		--sysconfdir=/etc/luarocks \
 		--with-lua=/usr \
 		--with-lua-include=/usr/include/lua5.1 \
 		--with-lua-lib=/usr/local/lib \
		--rocks-tree=/usr/local/

override_dh_auto_build:
	make build
	txt2man -t "luarocks 1" -r "LuaRocks" -v "" debian/luarocks.1.txt \
		> luarocks.1
	txt2man -t "luarocks-admin 1" -r "LuaRocks repository administration"\
	       	-v "" debian/luarocks-admin.1.txt > luarocks-admin.1

define LUAROCKS_CONF
rocks_trees = {
   home..[[/.luarocks]],
   [[/usr/local]]
}
endef
export LUAROCKS_CONF
override_dh_auto_install:
	mkdir -p $(DEB_DESTDIR)/etc/luarocks/
	mkdir -p $(DEB_DESTDIR)/usr/bin/
	for V in 5.1 5.2 5.3; do\
	  mkdir -p $(DEB_DESTDIR)/usr/share/lua/$$V/;\
	  cp -r src/luarocks $(DEB_DESTDIR)/usr/share/lua/$$V/;\
	done
	cp src/bin/luarocks $(DEB_DESTDIR)/usr/bin/
	cp src/bin/luarocks-admin $(DEB_DESTDIR)/usr/bin/
	sed -i -e '1c\#!/usr/bin/env lua-any\n-- Lua-Versions: 5.1 5.2 5.3' $(DEB_DESTDIR)/usr/bin/*
	sed -i -e '3d' $(DEB_DESTDIR)/usr/bin/*
	echo "$$LUAROCKS_CONF" > $(DEB_DESTDIR)/etc/luarocks/config.lua
	dh_lua -pluarocks -P$(DEB_DESTDIR)

override_dh_auto_clean:
	rm -f luarocks.1 luarocks-admin.1 .gitignore lua
	make clean || true

## luarocks 3.8.0%2Bdfsg1

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,17 @@
 Source: luarocks
 Section: interpreters
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
+Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
 Uploaders: Jérémy Lal <kapouer@melix.org>
 Build-Depends: debhelper-compat (= 13), lua-ldoc, lua5.1, liblua5.1-dev, wget, txt2man, unzip, dh-lua
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0.1
 Vcs-Browser: https://salsa.debian.org/lua-team/luarocks
 Vcs-Git: https://salsa.debian.org/lua-team/luarocks.git
 Homepage: https://luarocks.org/
 
 Package: luarocks
 Architecture: all
-Depends: lua-any, lua5.1 | lua5.2 | lua5.3, liblua5.1-dev | liblua5.2-dev | liblua5.3-dev, wget, ${misc:Depends}, zip, unzip
+Depends: lua-any, lua5.1 | lua5.3, liblua5.1-dev | liblua5.3-dev, wget, ${misc:Depends}, zip, unzip
 Recommends: lua-sec
 Description: deployment and management system for Lua modules
  This package contains LuaRocks, a tool for managing rocks.  A Lua rock is a
